﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bucherei
{
    internal class MedienCrudAdapter : ICRUD
    {
        public int Create(object o)
        {
            if (o is Buch) Medienverwaltung.GibInstanz().Anlegen((Buch)o);
            else if (o is CD) Medienverwaltung.GibInstanz().Anlegen((CD)o);
            else throw new Exception("wrong object type");
            return 1;
        }
        public ArrayList Read(object k = null)
        {
            ArrayList out_list = new ArrayList();
            if (k == null)
            {
                IEnumerable<Medium> liste = Medienverwaltung.GibInstanz().AlleLesen();
                foreach (Medium l in liste) out_list.Add(l);
            }
            else
            {
                string signatur = (string)k;
                Medium m = Medienverwaltung.GibInstanz().Lesen(signatur);
                if (m != null) out_list.Add(m);
            }
            return out_list;
        }
        public int Update(object o)
        {
            throw new NotImplementedException();
        }
        public int Delete(object k)
        {
            string signatur = (string)k;
            Medienverwaltung.GibInstanz().Loschen(signatur);
            return 1;
        }
    }
}
